org.apache.lucene.index

## Class MultiTermsEnum

- java.lang.Object
- - org.apache.lucene.index.TermsEnum
  - - org.apache.lucene.index.MultiTermsEnum

- All Implemented Interfaces:
    BytesRefIterator

      public final class MultiTermsEnum
      extends TermsEnum

  Exposes `TermsEnum` API, merged from `TermsEnum` API of sub-segments. This does a merge sort, by term text, of the sub-readers.
  WARNING: This API is experimental and might change in incompatible ways in the next release.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.index.TermsEnum

      `TermsEnum.SeekStatus`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.index.TermsEnum

      `EMPTY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `MultiTermsEnum(ReaderSlice[] slices)` Sole constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `docFreq()` Returns the number of documents containing the current term.
    `DocsEnum` | `docs(Bits liveDocs, DocsEnum reuse, int flags)` Get `DocsEnum` for the current term, with control over whether freqs are required.
    `DocsAndPositionsEnum` | `docsAndPositions(Bits liveDocs, DocsAndPositionsEnum reuse, int flags)` Get `DocsAndPositionsEnum` for the current term, with control over whether offsets and payloads are required.
    `Comparator<BytesRef>` | `getComparator()` Return the `BytesRef` Comparator used to sort terms provided by the iterator.
    `org.apache.lucene.index.MultiTermsEnum.TermsEnumWithSlice[]` | `getMatchArray()` Returns sub-reader slices positioned to the current term.
    `int` | `getMatchCount()` Returns how many sub-reader slices contain the current term.
    `BytesRef` | `next()` Increments the iteration to the next `BytesRef` in the iterator.
    `long` | `ord()` Returns ordinal position for current term.
    `TermsEnum` | `reset(org.apache.lucene.index.MultiTermsEnum.TermsEnumIndex[] termsEnumsIndex)` The terms array must be newly created TermsEnum, ie `BytesRefIterator.next()` has not yet been called.
    `TermsEnum.SeekStatus` | `seekCeil(BytesRef term, boolean useCache)` Expert: just like `TermsEnum.seekCeil(BytesRef)` but allows you to control whether the implementation should attempt to use its term cache (if it uses one).
    `boolean` | `seekExact(BytesRef term, boolean useCache)` Attempts to seek to the exact term, returning true if the term is found.
    `void` | `seekExact(long ord)` Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`.
    `BytesRef` | `term()` Returns current term.
    `String` | `toString()`
    `long` | `totalTermFreq()` Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term).

    - ### Methods inherited from class org.apache.lucene.index.TermsEnum

      `attributes, docs, docsAndPositions, seekCeil, seekExact, termState`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### MultiTermsEnum

          public MultiTermsEnum(ReaderSlice[] slices)

      Sole constructor.
      Parameters:
        `slices` - Which sub-reader slices we should merge.

  - ### Method Detail

    - #### getMatchCount

          public int getMatchCount()

      Returns how many sub-reader slices contain the current term. @see #getMatchArray

    - #### getMatchArray

          public org.apache.lucene.index.MultiTermsEnum.TermsEnumWithSlice[] getMatchArray()

      Returns sub-reader slices positioned to the current term.

    - #### term

          public BytesRef term()

      Description copied from class: `TermsEnum`
      Returns current term. Do not call this when the enum is unpositioned.
      Specified by:
        `term` in class `TermsEnum`

    - #### getComparator

          public Comparator<BytesRef> getComparator()

      Description copied from interface: `BytesRefIterator`
      Return the `BytesRef` Comparator used to sort terms provided by the iterator. This may return null if there are no items or the iterator is not sorted. Callers may invoke this method many times, so it's best to cache a single instance & reuse it.

    - #### reset

          public TermsEnum reset(org.apache.lucene.index.MultiTermsEnum.TermsEnumIndex[] termsEnumsIndex)
                          throws IOException

      The terms array must be newly created TermsEnum, ie `BytesRefIterator.next()` has not yet been called.
      Throws:
        `IOException`

    - #### seekExact

          public boolean seekExact(BytesRef term,
                          boolean useCache)
                            throws IOException

      Description copied from class: `TermsEnum`
      Attempts to seek to the exact term, returning true if the term is found. If this returns false, the enum is unpositioned. For some codecs, seekExact may be substantially faster than `TermsEnum.seekCeil(org.apache.lucene.util.BytesRef, boolean)`.
      Overrides:
        `seekExact` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekCeil

          public TermsEnum.SeekStatus seekCeil(BytesRef term,
                                      boolean useCache)
                                        throws IOException

      Description copied from class: `TermsEnum`
      Expert: just like `TermsEnum.seekCeil(BytesRef)` but allows you to control whether the implementation should attempt to use its term cache (if it uses one).
      Specified by:
        `seekCeil` in class `TermsEnum`
      Throws:
        `IOException`

    - #### seekExact

          public void seekExact(long ord)

      Description copied from class: `TermsEnum`
      Seeks to the specified term by ordinal (position) as previously returned by `TermsEnum.ord()`. The target ord may be before or after the current ord, and must be within bounds.
      Specified by:
        `seekExact` in class `TermsEnum`

    - #### ord

          public long ord()

      Description copied from class: `TermsEnum`
      Returns ordinal position for current term. This is an optional method (the codec may throw `UnsupportedOperationException`). Do not call this when the enum is unpositioned.
      Specified by:
        `ord` in class `TermsEnum`

    - #### next

          public BytesRef next()
                        throws IOException

      Description copied from interface: `BytesRefIterator`
      Increments the iteration to the next `BytesRef` in the iterator. Returns the resulting `BytesRef` or `null` if the end of the iterator is reached. The returned BytesRef may be re-used across calls to next. After this method returns null, do not call it again: the results are undefined.
      Returns:
        the next `BytesRef` in the iterator or `null` if the end of the iterator is reached.
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### docFreq

          public int docFreq()
                      throws IOException

      Description copied from class: `TermsEnum`
      Returns the number of documents containing the current term. Do not call this when the enum is unpositioned. `TermsEnum.SeekStatus.END`.
      Specified by:
        `docFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### totalTermFreq

          public long totalTermFreq()
                             throws IOException

      Description copied from class: `TermsEnum`
      Returns the total number of occurrences of this term across all documents (the sum of the freq() for each doc that has this term). This will be -1 if the codec doesn't support this measure. Note that, like other term measures, this measure does not take deleted documents into account.
      Specified by:
        `totalTermFreq` in class `TermsEnum`
      Throws:
        `IOException`

    - #### docs

          public DocsEnum docs(Bits liveDocs,
                      DocsEnum reuse,
                      int flags)
                        throws IOException

      Description copied from class: `TermsEnum`
      Get `DocsEnum` for the current term, with control over whether freqs are required. Do not call this when the enum is unpositioned. This method will not return null.
      Specified by:
        `docs` in class `TermsEnum`
      Parameters:
        `liveDocs` - unset bits are documents that should not be returned
        `reuse` - pass a prior DocsEnum for possible reuse
        `flags` - specifies which optional per-document values you require; see `DocsEnum.FLAG_FREQS`
      Throws:
        `IOException`
      See Also:
        `TermsEnum.docs(Bits, DocsEnum, int)`

    - #### docsAndPositions

          public DocsAndPositionsEnum docsAndPositions(Bits liveDocs,
                                              DocsAndPositionsEnum reuse,
                                              int flags)
                                                throws IOException

      Description copied from class: `TermsEnum`
      Get `DocsAndPositionsEnum` for the current term, with control over whether offsets and payloads are required. Some codecs may be able to optimize their implementation when offsets and/or payloads are not required. Do not call this when the enum is unpositioned. This will return null if positions were not indexed.
      Specified by:
        `docsAndPositions` in class `TermsEnum`
      Parameters:
        `liveDocs` - unset bits are documents that should not be returned
        `reuse` - pass a prior DocsAndPositionsEnum for possible reuse
        `flags` - specifies which optional per-position values you require; see `DocsAndPositionsEnum.FLAG_OFFSETS` and `DocsAndPositionsEnum.FLAG_PAYLOADS`.
      Throws:
        `IOException`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2000-2013 Apache Software Foundation. All Rights Reserved.